#include <QPushButton>
#include <QLineEdit>
#include <QLabel>
#include <QString>

#include "ARsql.h"

#include "ARDialogBCode.h"

ARDialogBCode::ARDialogBCode(QWidget *parent) : QDialog(parent)
 {
 	sql = new ARsql(this);

  QPalette pal(this->palette()); pal.setColor(QPalette::Base,QColor(0xff,0xff,0x99));
  _bcode = new QLabel(tr("Codice a barre dell'articolo da scaricare"),this);
  _bcode->setGeometry (10,10,300,24);
  bcode = new QLineEdit("",this); 
  bcode->setGeometry (10,40,300,24);
  bcode->setMaxLength(10); bcode->setPalette(pal);
 	
 	scarica = new QPushButton(QIcon("pic/scarico.png"),tr("Ok"),this);
  scarica->setGeometry(10,80,96,30);
 	annulla = new QPushButton(QIcon("pic/exit.png"),tr("Annulla"),this);
  annulla->setGeometry(120,80,96,30);
  connect(annulla,SIGNAL(clicked()),this,SLOT(reject()));
  connect(scarica,SIGNAL(clicked()),this,SLOT(accept()));

  setWindowTitle(tr("Scarico rapido articolo"));
  setWindowFlags(Qt::Window | Qt::MSWindowsFixedSizeDialogHint | Qt::WindowTitleHint | Qt::WindowSystemMenuHint);
  setGeometry(200,200,400,120);
 }

void ARDialogBCode::settaBCode(QString bcode) { this->bcode->setText(bcode); }

void ARDialogBCode::selezionaBCode()
 {
 	this->bcode->setFocus();
	this->bcode->selectAll();
 }

QString ARDialogBCode::prendiBCode() { return bcode->text(); }
