#include <QPushButton>
#include <QLineEdit>
#include <QCheckBox>
#include <QLabel>
#include <QString>
#include <QTabWidget>
#include <QMessageBox>
#include <QFileDialog>

#include "ARsql.h"

#include "ARDialogPref.h"

ARDialogPref::ARDialogPref(QWidget *parent) : QDialog(parent)
 {
 	sql = new ARsql(this);

  warnbox = new QMessageBox(tr("Avviso"),"c:\\",QMessageBox::Warning,0,0,0,this);
  warnbox->setWindowModality(Qt::WindowModal);

  tpage1 = new QWidget(this);
  tpage2 = new QWidget(this);
  tpage3 = new QWidget(this);
  tab = new QTabWidget(this); tab->setGeometry(5,5,540,305);
  tab->addTab(tpage1,QIcon("pic/backup.png"),tr("Backup"));
  tab->addTab(tpage2,QIcon("pic/password.png"),tr("Cambio password"));
  tab->addTab(tpage3,QIcon("pic/pref.png"),tr("Impostazioni varie"));
  current_tab=0;

  // Backup  
  _backpath  = new QLabel(tr("Cartella copie di sicurezza"),tpage1);             _backpath->setGeometry ( 10, 10,150,24);
  backpath   = new QLineEdit("",tpage1);                                         backpath->setGeometry  (150, 10,260,24);
  backpathb  = new QPushButton(QIcon("pic/folder.png"),tr("Sfoglia..."),tpage1); backpathb->setGeometry (420, 10, 80,24);
  backpath->setReadOnly(true);
  _mysqlpath = new QLabel(tr("Cartella mysql"),tpage1);                          _mysqlpath->setGeometry( 10, 70,150,24);
  mysqlpath  = new QLineEdit("",tpage1);                                         mysqlpath->setGeometry (150, 70,260,24);
  mysqlpathb = new QPushButton(QIcon("pic/folder.png"),tr("Sfoglia..."),tpage1); mysqlpathb->setGeometry(420, 70, 80,24);
  mysqlpath->setReadOnly(true);
  _datapath  = new QLabel(tr("Cartella dati mysql"),tpage1);                     _datapath->setGeometry ( 10,100,150,24);
  datapath   = new QLineEdit("",tpage1);                                         datapath->setGeometry  (150,100,260,24);
  datapathb  = new QPushButton(QIcon("pic/folder.png"),tr("Sfoglia..."),tpage1); datapathb->setGeometry (420,100, 80,24);
  datapath->setReadOnly(true);
  _dbpath    = new QLabel(tr("Cartella database"),tpage1);                       _dbpath->setGeometry   ( 10,130,150,24);
  dbpath     = new QLineEdit("",tpage1);                                         dbpath->setGeometry    (150,130,260,24);
  dbpathb    = new QPushButton(QIcon("pic/folder.png"),tr("Sfoglia..."),tpage1); dbpathb->setGeometry   (420,130, 80,24);
  dbpath->setReadOnly(true);  
  _msg = new QLabel(tr("Il backup dei file pu avvenire solo se si dispone dell'accesso diretto ai file e alle cartelle.\nIn ogni caso verr creato un dump dei dati in formato sql."),tpage1); _msg->setGeometry( 10,160,400,48);
  
  // Cambio password
  _oldpwd = new QLabel(tr("Vecchia password"),tpage2);        _oldpwd->setGeometry( 10, 10,150,24);
  oldpwd  = new QLineEdit("",tpage2);                         oldpwd->setGeometry (140, 10,200,24);
  _newpwd = new QLabel(tr("Nuova password"),tpage2);          _newpwd->setGeometry( 10, 70,150,24);
  newpwd  = new QLineEdit("",tpage2);                         newpwd->setGeometry (140, 70,200,24);
  _verpwd = new QLabel(tr("Verifica nuova password"),tpage2); _verpwd->setGeometry( 10,100,150,24);
  verpwd  = new QLineEdit("",tpage2);                         verpwd->setGeometry (140,100,200,24);
  oldpwd->setMaxLength(255); oldpwd->setEchoMode(QLineEdit::Password);
  newpwd->setMaxLength(255); newpwd->setEchoMode(QLineEdit::Password);
  verpwd->setMaxLength(255); verpwd->setEchoMode(QLineEdit::Password);
  
  // Varie
  ckprev = new QCheckBox("Attiva le anteprime di stampa",tpage3); ckprev->setGeometry(10,10,200,24);

 	salva = new QPushButton(QIcon("pic/floppy.png"),tr("Salva impostazioni"),this);
	salva->setGeometry(5,315,120,30);
 	annulla = new QPushButton(QIcon("pic/exit.png"),tr("Chiudi"),this);
  annulla->setGeometry(135,315,120,30);
  connect(annulla,SIGNAL(clicked()),this,SLOT(reject()));
  connect(salva,SIGNAL(clicked()),this,SLOT(savePref()));
  connect(tab,SIGNAL(currentChanged(int)),this,SLOT(cambiaTab(int)));
  connect(backpathb,SIGNAL(clicked()),this,SLOT(sfogliaDirBackPath()));
  connect(mysqlpathb,SIGNAL(clicked()),this,SLOT(sfogliaDirMysqlPath()));
  connect(datapathb,SIGNAL(clicked()),this,SLOT(sfogliaDirDataPath()));
  connect(dbpathb,SIGNAL(clicked()),this,SLOT(sfogliaDirDbPath()));

  setWindowFlags(Qt::Window | Qt::MSWindowsFixedSizeDialogHint | Qt::WindowTitleHint | Qt::WindowSystemMenuHint);
  setWindowTitle(tr("Impostazioni programma"));
  setGeometry(200,200,550,350);
 }

void ARDialogPref::sfogliaDirBackPath()
 {
 	QFileDialog filebox;
 	QString path;

 	path=filebox.getExistingDirectory(this,"Scegli la cartella dove mettere le copie di sicurezza.",backpath->text());
 	if(path!="") backpath->setText(path);
 }

void ARDialogPref::sfogliaDirMysqlPath()
 {
 	QFileDialog filebox;
 	QString path;

 	path=filebox.getExistingDirectory(this,"Scegli la cartella di installazione di MySql.",mysqlpath->text());
 	if(path!="") mysqlpath->setText(path);
 }

void ARDialogPref::sfogliaDirDataPath()
 {
 	QFileDialog filebox;
 	QString path;

 	path=filebox.getExistingDirectory(this,"Scegli la cartella dati di MySql.",datapath->text());
 	if(path!="") datapath->setText(path);
 }

void ARDialogPref::sfogliaDirDbPath()
 {
 	QFileDialog filebox;
 	QString path;

 	path=filebox.getExistingDirectory(this,"Scegli la cartella del database.",dbpath->text());
 	if(path!="") dbpath->setText(path);
 }

void ARDialogPref::loadPref()
 {
  // Backup
  backpath->setText(sql->getPref(6,"pref_varie"));
  mysqlpath->setText(sql->getPref(3,"pref_varie"));
  datapath->setText(sql->getPref(4,"pref_varie"));
  dbpath->setText(sql->getPref(5,"pref_varie"));
  // Varie
  if(sql->getPref(7,"pref_varie")=="1") ckprev->setCheckState(Qt::Checked); else ckprev->setCheckState(Qt::Unchecked);   
 }

void ARDialogPref::savePref()
 {
 	QString back_path,mysql_path,data_path,db_path;
 	QString old_pwd,new_pwd,ver_pwd;
 	
 	if(current_tab==0) // Backup
 	 {
 	 	if(!checkFormBak())
 	 	 {
 	    back_path=backpath->text();
 	    mysql_path=mysqlpath->text();
 	    data_path=datapath->text();
 	    db_path=dbpath->text();
      if(sql->doQuery("UPDATE pref_varie SET mysql_path='"+mysql_path+"', back_path='"+back_path+"', data_path='"+data_path+"', db_path='"+db_path+"'"))
       {
        warnbox->setText(tr("Impostazioni di backup salvate!"));
        warnbox->exec();
       }
     }
   }
 	if(current_tab==1) // Cambio password
 	 {
 	 	if(!checkFormPwd())
 	 	 {
 	    new_pwd=quote(newpwd->text());
 	    old_pwd=quote(oldpwd->text());
      ver_pwd=quote(verpwd->text());
      if(sql->doQuery("UPDATE pref_varie SET password='"+new_pwd+"'"))
       {
        warnbox->setText(tr("Password cambiata con successo!"));
        warnbox->exec();
       }
      oldpwd->setText(""); 
      newpwd->setText(""); 
      verpwd->setText(""); 
     }
   }
	if(current_tab==2) // Varie
 	 {
 	 	//if(!checkFormBak())
 	 	 {
      QString usepreview;
      if(ckprev->checkState()==Qt::Checked) usepreview="1"; else usepreview="0";
      if(sql->doQuery("UPDATE pref_varie SET usepreview='"+usepreview+"'"))
       {
        warnbox->setText(tr("Impostazioni varie salvate!"));
        warnbox->exec();
       }
     }
   }
 }

bool ARDialogPref::checkFormBak() // TODO
 {
 	if(quote(backpath->text())=="")
 	 {
 	  warnbox->setText(tr("Devi specificare la cartella per le copie di sicurezza!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	/*if(quote(mmbasso->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il margine basso!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(numr->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il numero di etichette per colonna!"));
 	  warnbox->exec();
 	  return true;
 	 }*/
 	return false;
 }

bool ARDialogPref::checkFormPwd()
 {
 	if(oldpwd->text()!=sql->prendiPwd())
 	 {
 	  warnbox->setText(tr("Vecchia password errata!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(newpwd->text()!=verpwd->text())
 	 {
 	  warnbox->setText(tr("La nuova password non corrisponde con\nla password di verifica!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(newpwd->text().length()<=5)
 	 {
 	  warnbox->setText(tr("La nuova password inserita  troppo corta.\nInserisci una password di minimo 6 caratteri!"));
 	  warnbox->exec();
 	  return true;
 	 }
 	return false;
 }

void ARDialogPref::cambiaTab(int n) {	current_tab=n; }

void ARDialogPref::attivaTab(int n) {	tab->setCurrentIndex(n); }

QString ARDialogPref::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }
