#include <QPushButton>
#include <QGroupBox>
#include <QLabel>
#include <QLineEdit>
#include <QHeaderView>
#include <QTableWidget>
#include <QTableWidgetItem>
#include <QMessageBox>
#include <QTextEdit>

#include "ARFinestra.h"
#include "ARFattura.h"
#include "ARsql.h"

#include "ARDialogServizi.h"

ARDialogServizi::ARDialogServizi(QWidget *parent) : QDialog(parent)
 {
 	setWindowTitle(tr("Aggiungi servizi alla fattura"));
 	mainWin=(ARFinestra *)parent;
 	num_col=6;
 	dettagli=false;
 	printBollaID="0"; bollaID="0"; fornitoreID="0";

  sql      = new ARsql(this);
  infobox  = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox  = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  yesnobox = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);

 	add = new QPushButton(QIcon("pic/fatture_add.png"),tr(" Aggiungi tutti"),this);
 	add->setGeometry(600,298,175,34); add->setIconSize(QSize(26,26));
 	addsel = new QPushButton(QIcon("pic/fatture_add.png"),tr(" Aggiungi selezionato"),this);
 	addsel->setGeometry(600,332,175,34); addsel->setIconSize(QSize(26,26));
 	esci = new QPushButton(QIcon("pic/exit.png"),tr(" Chiudi"),this);
 	esci->setGeometry(600,366,175,34); esci->setIconSize(QSize(26,26));

 	cornice = new QGroupBox(tr("Ricerca servizi da inserire nella fattura "),this);
 	cornice->setGeometry(0,291,598,109);


  _articolo    = new QLabel(tr("Codice"),cornice);      _articolo->setGeometry   (  8, 15,  80, 24);
  articolo     = new QLineEdit("",cornice);             articolo->setGeometry    ( 48, 15, 200, 24);
  articolo->setMaxLength(255);
  _descrizione = new QLabel(tr("Descrizione"),cornice); _descrizione->setGeometry(258, 15,  80, 24);
  descrizione  = new QLineEdit("",cornice);             descrizione->setGeometry (318, 15, 270, 24);
  descrizione->setMaxLength(255);
  _prezzo = new QLabel(tr("Prezzo"),cornice);           _prezzo->setGeometry     (  8, 45,  80, 24);
  prezzo = new QLineEdit("",cornice);                   prezzo->setGeometry      ( 48, 45, 130, 24);
  prezzo->setMaxLength(35);
  _iva  = new QLabel(tr("IVA(%)"),cornice);             _iva->setGeometry        (188, 45,  80, 24);
  iva  = new QLineEdit("",cornice);                     iva->setGeometry         (228, 45,  60, 24);
  iva->setMaxLength(3);
//  prezzo->setValidator(new QDoubleValidator(-50000000.0,50000000.0,2,prezzo));

 	dummy = new QPushButton("",cornice); dummy->setGeometry(0,0,0,0);
 	reset = new QPushButton(QIcon("pic/no_search.png"),tr("Azzera"),cornice);
  reset->setGeometry(402,83,96,24);
 	search = new QPushButton(QIcon("pic/search.png"),tr("Cerca"),cornice);
  search->setGeometry(500,83,96,24);
  
  _table = new QLabel(tr("Servizi da inserire nella fattura relativa al cliente:"),this); _table->setGeometry(5,0,300,24);
  _msg   = new QLabel("",this); _msg->setGeometry(230,0,300,24);
  table = new QTableWidget(this);
  table->setSortingEnabled(true);
  table->setAlternatingRowColors(true);
  table->setEditTriggers(QAbstractItemView::NoEditTriggers);
  table->setSelectionMode(QAbstractItemView::SingleSelection);
  table->setSelectionBehavior(QAbstractItemView::SelectRows);
 	for(int i=0;i<num_col;i++) table->insertColumn(i);
 	table->setColumnWidth(0,20);
 	table->setColumnWidth(1,160);
 	table->setColumnWidth(2,320);
 	table->setColumnWidth(3,100);
 	table->setColumnWidth(4,50);
 	table->setColumnWidth(5,100);
 	table->hideColumn(0);
 	table->setHorizontalHeaderLabels(QStringList() << "ID" << "Codice" << "Descrizione" << "Prezzo" << "IVA(%)" << "Prezzo ivato");
 	table->setGeometry(0,33,775,256);

 	connect(search,SIGNAL(clicked()),this,SLOT(visServizi()));
 	connect(reset,SIGNAL(clicked()),this,SLOT(resRicerca()));
  connect(articolo,SIGNAL(returnPressed()),this,SLOT(visServizi()));
  connect(descrizione,SIGNAL(returnPressed()),this,SLOT(visServizi()));
  connect(prezzo,SIGNAL(returnPressed()),this,SLOT(visServizi()));
  connect(iva,SIGNAL(returnPressed()),this,SLOT(visServizi()));
  connect(add,SIGNAL(clicked()),this,SLOT(addAll()));
  connect(addsel,SIGNAL(clicked()),this,SLOT(addSelection()));
 	connect(esci,SIGNAL(clicked()),this,SLOT(reject()));

  yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
  infobox->setWindowModality(Qt::WindowModal);
  warnbox->setWindowModality(Qt::WindowModal);

  setWindowFlags(Qt::Window | Qt::MSWindowsFixedSizeDialogHint | Qt::WindowTitleHint | Qt::WindowSystemMenuHint);
  setGeometry(15,120,775,400);
 }

void ARDialogServizi::visServizi()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString query,articolo,descrizione,prezzo,iva,fornitoreID;
 	bool primo;
 	int r;

 	table->setRowCount(0);
 	r=0; primo=true;
 	query = "SELECT *,TRUNCATE(prezzo+prezzo*iva/100,2) AS ivato FROM servizi";
 	articolo=quote(this->articolo->text(),true);
 	descrizione=quote(this->descrizione->text(),true);
 	prezzo=quote(this->prezzo->text(),true);
 	iva=quote(this->iva->text());
 	fornitoreID=this->fornitoreID;
 	if(articolo!="")    { if(primo) { query+=" WHERE articolo LIKE '%"+articolo+"%'"; primo=false; }       else { query+=" AND articolo LIKE '%"+articolo+"%'"; } }
 	if(descrizione!="") { if(primo) { query+=" WHERE descrizione LIKE '%"+descrizione+"%'"; primo=false; } else { query+=" AND descrizione LIKE '%"+descrizione+"%'"; } }
 	if(prezzo!="")      { if(primo) { query+=" WHERE prezzo LIKE '%"+prezzo+"%'"; primo=false; }           else { query+=" AND prezzo LIKE '%"+prezzo+"%'"; } }
 	if(iva!="")         { if(primo) { query+=" WHERE iva='"+iva+"'"; primo=false; }                        else { query+=" AND iva='"+iva+"'"; } }
 	query+=" ORDER BY descrizione";
 	rs=sql->doQueryRS(query);
 	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
   	  table->insertRow(r); table->setRowHeight(r,18);
   	  table->setItem(r,0,inserisciRiga(row[0]));
   	  table->setItem(r,1,inserisciRiga(row[1]));
   	  table->setItem(r,2,inserisciRiga(row[2]));
   	  table->setItem(r,3,inserisciRiga(row[3],Qt::AlignRight));
   	  table->setItem(r,4,inserisciRiga(row[4],Qt::AlignRight));
   	  table->setItem(r,5,inserisciRiga(row[9],Qt::AlignRight)); // Prezzo ivato
   	  r++;
     }
    this->dummy->setFocus();
    mysql_free_result(rs);
    if(r==0) 
     {
     	infobox->setText(tr("Nessun servizio trovato!"));
 	    infobox->exec();
     }
   }
 }

QTableWidgetItem *ARDialogServizi::inserisciRiga(const char *str, int alig)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	item->setTextAlignment(alig);
 	return item;
 }

QTableWidgetItem *ARDialogServizi::inserisciRiga(QString str, int alig)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	item->setTextAlignment(alig);
 	return item;
 }

void ARDialogServizi::resRicerca()
 {
 	articolo->clear();
 	descrizione->clear();
 	prezzo->clear();
 	iva->clear();
 }

QString ARDialogServizi::getElemento(int r, int c, QString def)
 {
 	if(table->item(r,c)) return table->item(r,c)->text(); else return def;
 }

QString ARDialogServizi::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }

void ARDialogServizi::addAll()
 {
 	// TODO da fare se si vuole
 	infobox->setText(tr("Funzione non disponibile"));
 	infobox->exec();
 	return;


 	if(table->rowCount()<=0)
 	 {
 	 	infobox->setText(tr("Nessun servizio da inserire"));
 	  infobox->exec();
 	  return;
 	 }
 	else
 	 {
 	 	QString aux;
 	 	int n;

    for(int i=0;i<table->rowCount();i++)
     {
      n=desttable->rowCount();
      desttable->insertRow(n); desttable->setRowHeight(n,18);
 	   	for(int c=0;c<3;c++)
 	 	   {
 	 	 	  aux=table->item(i,c)->text();
        if(c==0) sql->doQuery("UPDATE articoli SET fatturato='1' WHERE articoloID='"+aux+"'"); 
 	 	    desttable->setItem(n,c,inserisciRiga(aux));
	     }
	    desttable->setItem(n,3,inserisciRiga("1",Qt::AlignRight)); // Quantit
	    double qta=desttable->item(n,3)->text().toDouble();
	    aux=table->item(i,5)->text(); // Prezzo al pubblico (unitario)
	    double pre_uni=aux.toDouble();
	    desttable->setItem(n,4,inserisciRiga(aux,Qt::AlignRight));
	    double pre_tot=pre_uni*qta; // Prezzo totale
	    desttable->setItem(n,6,inserisciRiga(aux.sprintf("%.2lf",pre_tot),Qt::AlignRight));
	    aux=table->item(i,11)->text(); // Iva
	    desttable->setItem(n,5,inserisciRiga(aux,Qt::AlignRight));

      for(int j=0;j<num_col;j++) desttable->item(i,j)->setFlags(Qt::ItemIsSelectable);
	   }
   }
 	visServizi();
 }

void ARDialogServizi::addSelection()
 {
 	if(table->currentRow()<0)
 	 {
 	 	infobox->setText(tr("Nessun servizio selezionato"));
 	  infobox->exec();
 	  return;
 	 }
 	else
 	 {
 	 	QString aux;
 	 	int n;

    n=desttable->rowCount();
    desttable->insertRow(n); desttable->setRowHeight(n,18);
    // Codice a barre (non usato)
    desttable->setItem(n,0,inserisciRiga("",Qt::AlignLeft));
    desttable->item(n,0)->setBackgroundColor(QColor(100,255,100));
    desttable->item(n,0)->setTextColor(QColor(100,255,100));
    desttable->item(n,0)->setFlags(0);
    desttable->item(n,0)->setCheckState(Qt::Checked);
    // Articolo
	  aux=table->item(table->currentRow(),1)->text(); 
	  desttable->setItem(n,1,inserisciRiga(aux,Qt::AlignLeft));
    // Descrizione
	  aux=table->item(table->currentRow(),2)->text();
	  desttable->setItem(n,2,inserisciRiga(aux,Qt::AlignLeft));
    // Quantit
	  desttable->setItem(n,3,inserisciRiga("1",Qt::AlignRight));
	  desttable->item(n,3)->setFlags(Qt::ItemIsSelectable);
	  // Prezzo unitario
	  aux=table->item(table->currentRow(),3)->text();
	  desttable->setItem(n,4,inserisciRiga(aux,Qt::AlignRight));	  	
    // Iva
	  aux=table->item(table->currentRow(),4)->text();
	  desttable->setItem(n,5,inserisciRiga(aux,Qt::AlignRight));
    // Prezzo totale
	  desttable->setItem(n,6,inserisciRiga("",Qt::AlignRight));
	  desttable->item(n,6)->setFlags(Qt::ItemIsSelectable);
   }
  visServizi();
  padre->calcTotali();
 }

void ARDialogServizi::settaPadre(ARFattura *p) { padre=p; }

void ARDialogServizi::setDestTable(QTableWidget *dtb) { desttable=dtb; }

void ARDialogServizi::setBollaID(QString id) { bollaID=id; }

void ARDialogServizi::setPrintBollaID(QString id) { printBollaID=id; }

void ARDialogServizi::setFornitoreID(QString id) { fornitoreID=id; }

QString ARDialogServizi::getBollaID() { return bollaID; }

QString ARDialogServizi::getPrintBollaID() { return printBollaID; }

QString ARDialogServizi::getFornitoreID() { return fornitoreID; }

void ARDialogServizi::setMsg(QString m) { _msg->setText("<b>"+m+"</b>"); }
