#include <QPushButton>
#include <QLineEdit>
#include <QLabel>
#include <QString>
#include <QIntValidator>

#include "ARDialogSetup.h"

ARDialogSetup::ARDialogSetup(QWidget *parent) : QDialog(parent)
 {
  setWindowTitle(tr("Settaggi programma"));
  _server_addr = new QLabel(tr("Indirizzo del server"),this);         _server_addr->setGeometry(10,10,150,24);
   server_addr = new QLineEdit("",this);                               server_addr->setGeometry(160,10,140,24);
   server_addr->setMaxLength(255);
  _server_port = new QLabel(tr("Porta del server"),this);             _server_port->setGeometry(10,40,150,24);
   server_port = new QLineEdit("",this);                               server_port->setGeometry(160,40,60,24);
   server_port->setValidator(new QIntValidator(0,65536,server_port));
  _user_log    = new QLabel(tr("Nome utente del database"),this);     _user_log->setGeometry(10,70,150,24);
   user_log    = new QLineEdit("",this);                               user_log->setGeometry(160,70,140,24);
   user_log->setMaxLength(255);
  _user_pwd    = new QLabel(tr("Password utente del database"),this); _user_pwd->setGeometry(10,100,150,24);
   user_pwd    = new QLineEdit("",this);                               user_pwd->setGeometry(160,100,140,24);
   user_pwd->setEchoMode(QLineEdit::Password);
   user_pwd->setMaxLength(255);
  _db_name     = new QLabel(tr("Nome database"),this);                _db_name->setGeometry(10,130,150,24);
   db_name     = new QLineEdit("",this);                               db_name->setGeometry(160,130,140,24);
   db_name->setMaxLength(255);

 	scarica = new QPushButton(QIcon("pic/floppy.png"),tr("Salva impostazioni"),this);
  scarica->setGeometry(10,190,120,30);
 	annulla = new QPushButton(QIcon("pic/exit.png"),tr("Esci dal programma"),this);
  annulla->setGeometry(135,190,120,30);
  connect(annulla,SIGNAL(clicked()),this,SLOT(reject()));
  connect(scarica,SIGNAL(clicked()),this,SLOT(accept()));

  setWindowFlags(Qt::Window | Qt::MSWindowsFixedSizeDialogHint | Qt::WindowTitleHint | Qt::WindowSystemMenuHint);
  setGeometry(200,200,310,230);
 }

void ARDialogSetup::setServerAddr(QString addr) { server_addr->setText(addr); }

void ARDialogSetup::setServerPort(QString port) { server_port->setText(port); }

void ARDialogSetup::setUserLog(QString log) { user_log->setText(log); }

void ARDialogSetup::setUserPwd(QString pwd) { user_pwd->setText(pwd); }

void ARDialogSetup::setDbName(QString name) { db_name->setText(name); }

QString ARDialogSetup::getServerAddr() { return server_addr->text(); }

QString ARDialogSetup::getServerPort() { return server_port->text(); }

QString ARDialogSetup::getUserLog() { return user_log->text(); }

QString ARDialogSetup::getUserPwd() { return user_pwd->text(); }

QString ARDialogSetup::getDbName() { return db_name->text(); }
