#ifndef ARFINESTRA_H
#define ARFINESTRA_H

#include <QMainWindow>

#include "ARsql.h"

class QMenuBar;
class QMenu;
class QAction;
//class QInputDialog;
class QMessageBox;
class QLineEdit;
class QComboBox;
class QPushButton;
class QTableWidget;
class QGroupBox;
class QTextDocument;
class QCloseEvent;
class QResizeEvent;
class QString;
class QProcess;
class QDir;
class QDesktopWidget;
class QToolBar;

class ARsql;
class ARMainMenu;
class ARBarra;
class ARFornitore;
class ARCliente;
class ARServizio;
class ARBolla;
class ARFattura;
class ARAzienda;
class ARScadenza;
class ARArticolo;
class AROption;
class ARGrigliaFor;
class ARGrigliaCli;
class ARGrigliaSer;
class ARGrigliaBol;
class ARGrigliaFat;
class ARGrigliaSca;
class ARGrigliaOpt;
class ARTipoArticolo;
class ARGrigliaTipoArt;
class ARCarico;
class ARScarico;
class ARStampante;
class ARDialogScadenza;
class ARDialogStampe;
class ARDialogPref;
class ARDialogSetup;
class ARDialogBackup;
class ARDialogInfo;
class ARDialogBCode;
class AROrologio;
class ARStat;

class ARFinestra : public QMainWindow
 {
  Q_OBJECT

  public:
   ARsql *sql,*sql2;
   ARMainMenu *mainMenu;
   ARBarra *barra;

   ARFinestra(QWidget *parent = 0);
   ARFornitore *prendiAddFor();
   void disableAll(bool);
   void calcTotaliFattura();

  public slots:
   void menuPrincipale();
   void controllaScadenze();
   void addMerce();
   void scaricoMerce();
   void scaricoMerceFor();
   void cassaRapida();
   void resoMerce();
   void addBolla();
   void editBolla();
   void addPrintBolla();
   void printBolla();
   void visBolle();
   void addFattura();
   void editFattura();
   void addPrintFattura();
   void printFattura();
   void printFatturaSalvata();
   void visFatture();
   void vendutaMerce();
   void visAzienda();
   void addFornitore();
   void editFornitore();
   void visFornitori();
   void addCliente();
   void editCliente();
   void visClienti();
   void addScadenza();
   void editScadenza();
   void visScadenze();
   void addTipoArt();
   void editTipoArt();
   void visTipoArt();
   void editArticolo();
   void editOpzione();
   void addColore();
   void editColore();
   void visColori();
   void addFondo();
   void editFondo();
   void visFondi();
   void addTacco();
   void editTacco();
   void visTacchi();
   void addStagione();
   void editStagione();
   void visStagioni();
   void addServizio();
   void editServizio();
   void visServizi();
   void visStatistiche(int t=0);
   void visStatAndamenti();
   void visStatStatistiche();
   void prefStampe();
   void prefMisc();
   void stampaEtichette();
   void stampaMagazzino();
   void stampaIntestAzi();
   void stampaIntestFor();
   void stampaFornitori();
   void stampaIntestCli();
   void stampaClienti();
   void stampaServizi();
   void hidePrezzo(bool);
   void backupDb();
   void mostraManuale();
   void mostraAbout();
   void mostraCalcolatrice();
   void mostraRubrica();
   void Esci();
   ARScarico *getARScaricoP();
   bool passwordChecked();

  protected:
   virtual void closeEvent(QCloseEvent *);
   virtual void resizeEvent(QResizeEvent *);

  private:
   ARFornitore *addFor;
   ARCliente *addCli;
   ARServizio *addSer;
   ARBolla *addBol;
   ARFattura *addFat;
   ARScadenza *addSca;
   ARAzienda *addAzi;
   ARArticolo *addArt;
   AROption *addOpt;
   ARGrigliaFor *griFor;
   ARGrigliaCli *griCli;
   ARGrigliaSer *griSer;   
   ARGrigliaOpt *griOpt;
   ARGrigliaBol *griBol;
   ARGrigliaFat *griFat;
   ARGrigliaSca *griSca;
   ARTipoArticolo *addTiArt;
   ARGrigliaTipoArt *griTiArt;
   ARCarico *carico;
   ARScarico *scarico;
   ARStampante *stampe;
   ARDialogScadenza *scadbox;
   ARDialogStampe *pstampebox;
   ARDialogPref *prefbox;
   ARDialogSetup *setupbox;
   ARDialogBackup *backupbox;
   ARDialogBCode *bcodebox;
   ARDialogInfo *about;
   AROrologio *orologio;
   ARStat *stat;
   QDesktopWidget *scr;
   QMessageBox *infobox,*warnbox,*errorbox,*yesnobox;
   QToolBar *tool;
   QAction *calcTl,*rubrTl,*backTl;
   QMenuBar *menubar;
   QAction *newforMnu,*newcliMnu,*newfatMnu,*newbolMnu,*newscaMnu,*esciMnu;
   QAction *visforMnu,*viscliMnu,*visownMnu,*visfatMnu,*visddtMnu,*visscaMnu;
   QAction *caricoMnu,*scaricoMnu,*resoMnu,*vendutiMnu,*eticMnu,*stmagMnu,*ckprezMnu;
   QAction *statrieMnu,*stattreMnu,*statstaMnu;
   QAction *newtartMnu,*vistartMnu;
   QAction *newColoreMnu,*visColoreMnu,*newFondoMnu,*visFondoMnu,*newTaccoMnu,*visTaccoMnu,*newStagioneMnu,*visStagioneMnu;
   QAction *newServiziMnu,*visServiziMnu;
   QAction *prefvarMnu,*prefstaMnu;
   QAction *toolcalMnu,*toolrubMnu,*toolbakMnu;
   QAction *manMnu,*infoMnu;
   QMenu *menu1,*menu2,*menu3,*menu4,*subm4_1,*subm4_2,*subm4_3,*subm4_4,*subm4_5,*menu5,*menu6,*menu7,*menu8,*menu9;
   //QString fornitoreID,clienteID;
  
   void settaGeometria(bool);
   void addAzienda();
   bool esisteAzienda();
   void hideAll();
   void setupDatabase();
 };

#endif
