#ifndef ARFORNITORE_H
#define ARFORNITORE_H

#define ARFORNITORE_ADD  0
#define ARFORNITORE_EDIT 1

#include <QWidget>

class QPushButton;
class QGroupBox;
class QLineEdit;
class QLabel;
class QMessageBox;
class QRegExp;
class QTableWidget;
class QTableWidgetItem;

class ARFinestra;
class ARsql;
class ARDialogIndirReso;
class ARDialogProv;
class ARDialogCAP;

class ARFornitore : public QWidget
 {
  Q_OBJECT

  public:
   QGroupBox *cornice;
   QPushButton *esegui,*addindr,*editindr,*delindr,*cercap,*cercapr;
   QLineEdit *nome,*etich,*indr,*cap,*citta,*prov,*nazio,*tel,*fax,*cell,*piva,*cf;
   QLineEdit *banca,*abi,*cab,*cin,*cc;
   QLineEdit *email,*sitoweb;
   QTableWidget *tableindr;

   ARFornitore(QWidget *parent = 0);
   bool setForm(QString);
   void clearForm();
   void settaFormAdd();
   void settaFormEdit();
   void setFornitoreID(QString);
   void setAzione(int);
   bool isAzione(int);
   void visIndirReso();
   QTableWidgetItem *inserisciRiga(QString);
   QTableWidgetItem *inserisciRiga(const char *);

  public slots:
   void delIndirReso();
   void addFornitore();
   void addIndirReso();
   void editIndirReso();
   void cercaProvincia();
   void cercaCAP();
   
  private:
   ARFinestra *mainWin;
   ARDialogIndirReso *indresobox;
   ARDialogProv *provbox;
   ARDialogCAP *capbox;
   ARsql *sql;
   int num_col;
   QMessageBox *yesnobox,*infobox,*warnbox;
   QString fornitoreID;
   QLabel *_nome,*_etich,*_indr,*_cap,*_citta,*_prov,*_nazio,*_tel,*_fax,*_cell,*_piva,*_cf;
   QLabel *_datibanca,*_banca,*_abi,*_cab,*_cin,*_cc;
   QLabel *_datiweb,*_email,*_sitoweb;
   QLabel *_indireso;
   QRegExp *reg_email;
   int azione;

   bool checkForm();
   QString quote(QString, bool like = false);
 };

#endif
