#ifndef ARGRIGLIASCA_H
#define ARGRIGLIASCA_H

#include <QWidget>
#include <QDate>

class QTableWidget;
class QGroupBox;
class QTableWidgetItem;
class QPushButton;
class QLineEdit;
class QComboBox;
class QLabel;
class QMessageBox;
class QMenu;
class QAction;
class QContextMenuEvent;
class QDateEdit;
class QCheckBox;

class ARsql;

class ARGrigliaSca : public QWidget
 {
  Q_OBJECT

  public:
   QTableWidget *table;
   QPushButton *edit,*del,*search,*reset,*stampa;
   QLineEdit *note,*somma,*descr;
   QDateEdit *di;
   QCheckBox *ckdata;
   QAction *editCMnu,*delCMnu,*pagaCMnu,*npagCMnu;
   QComboBox *listaFor,*listaStato;

   ARGrigliaSca(QWidget *parent = 0);
   void settaGeometria(int,int);
   QTableWidgetItem *inserisciRiga(QString);
   QTableWidgetItem *inserisciRiga(const char *);
   bool populateFor(QString);

  public slots:
   void visScadenze(int);
   void visScadenze(QDate);
   void visScadenze();
   void delScadenze();
   void pagaScadenze();
   void nonPagaScadenze();
   void resRicerca();

  protected:
   void contextMenuEvent(QContextMenuEvent *event);

  private:
   int num_col;
   ARsql *sql;
   QMessageBox *infobox,*warnbox,*yesnobox;
   QGroupBox *cornice;
   QLabel *_for,*_note,*_somma,*_descr,*_di,*_stato;

   QString quote(QString, bool like = false);
 };

#endif
