#include <QTableWidget>
#include <QTableWidgetItem>
#include <QGroupBox>
#include <QPushButton>
#include <QLineEdit>
#include <QLabel>
#include <QMessageBox>

#include "ARFinestra.h"
#include "ARsql.h"

#include "ARGrigliaTipoArt.h"

ARGrigliaTipoArt::ARGrigliaTipoArt(QWidget *parent) : QWidget(parent)
 {
 	mainWin=(ARFinestra *)parent;
 	num_col=6;
 	sql = new ARsql(this);
  infobox  = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox  = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  yesnobox = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);
 	cornice = new QGroupBox(tr("Ricerca tipologia "),this);

  _descr = new QLabel(tr("Descrizione"),cornice); _descr->setGeometry( 8,15,100,24);
  descr  = new QLineEdit("",cornice);             descr->setGeometry (78,15,300,24);
  _iva   = new QLabel(tr("IVA (%)"),cornice);     _iva->setGeometry  ( 8,45,100,24);
  iva    = new QLineEdit("",cornice);             iva->setGeometry   (78,45, 50,24);
  iva->setValidator(new QIntValidator(0,100,iva));
  iva->setMaxLength(3);

 	edit = new QPushButton(QIcon("pic/edit.png"),tr("Visualizza"),this);
 	del = new QPushButton(QIcon("pic/delete.png"),tr("Cancella"),this);
 	reset = new QPushButton(QIcon("pic/no_search.png"),tr("Azzera"),cornice);
  reset->setGeometry(503,83,96,24);
 	search = new QPushButton(QIcon("pic/search.png"),tr("Cerca"),cornice);
  search->setGeometry(601,83,96,24);
 	table = new QTableWidget(this);
  table->setSortingEnabled(true);
  table->setAlternatingRowColors(true);
  table->setEditTriggers(QAbstractItemView::NoEditTriggers);
  table->setSelectionMode(QAbstractItemView::SingleSelection);
  table->setSelectionBehavior(QAbstractItemView::SelectRows);
 	for(int i=0;i<num_col;i++) table->insertColumn(i);
 	table->setColumnWidth(0,20);
 	table->setColumnWidth(1,140);
 	table->setColumnWidth(2,30);
 	table->setColumnWidth(3,50);
 	table->setColumnWidth(4,440);
 	table->setColumnWidth(5,250);
 	table->setHorizontalHeaderLabels(QStringList() << "ID" << "Descrizione" << "IVA" << "Sconto" << "Misure" << "Campi");
 	table->hideColumn(0);
 	
 	connect(del,SIGNAL(clicked()),this,SLOT(delTipoArt()));
 	connect(search,SIGNAL(clicked()),this,SLOT(visTipoArt()));
 	connect(reset,SIGNAL(clicked()),this,SLOT(resRicerca()));
  connect(descr,SIGNAL(returnPressed()),this,SLOT(visTipoArt()));
  connect(iva,SIGNAL(returnPressed()),this,SLOT(visTipoArt()));

 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
 	yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
  hide();
 }

void ARGrigliaTipoArt::settaGeometria(int lar, int alt)
 {
  setGeometry(0,61,lar,alt-70);
 	table->setGeometry(0,0,lar,alt-220);
 	cornice->setGeometry(2,alt-222,700,110);
  edit->setGeometry     (704,alt-213,96,24);
  del->setGeometry      (704,alt-188,96,24);
 }

void ARGrigliaTipoArt::visTipoArt()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString query,descr,iva,aux,mis,cam;
 	bool primo;
 	int r;
 	
 	table->setRowCount(0);
 	r=0; primo=true;
 	query="SELECT * FROM tipi_articolo";
 	descr = quote(this->descr->text(),true);
 	iva   = quote(this->iva->text(),true);
 	if(descr!="") { if(primo) { query+=" WHERE descrizione LIKE '%"+descr+"%'"; primo=false; } else { query+=" AND descrizione LIKE '%"+descr+"%'"; } }
 	if(iva!="")   { if(primo) { query+=" WHERE iva='"+iva+"'"; primo=false; } else { query+=" AND iva='"+iva+"'"; } }
 	query+=" ORDER BY descrizione";
 	rs=sql->doQueryRS(query);
 	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
     	mis=""; aux=""; cam="";
   	  table->insertRow(r); table->setRowHeight(r,18);
   	  table->setItem(r,0,inserisciRiga(row[0]));
   	  table->setItem(r,1,inserisciRiga(row[1]));
   	  table->setItem(r,2,inserisciRiga(row[row_iva]));
   	  table->setItem(r,3,inserisciRiga(row[row_iva+1]));
   	  for(int i=0;i<num_mis-1;i++)
   	   {
   	   	aux=row[i+2]; if(aux=="1") mis+=etichette.at(i)+", ";
   	   }
   	  mis.chop(2);
   	  aux=row[num_mis-1+2]; if(aux=="1") mis=tr("Nessuna misura");
   	  table->setItem(r,4,inserisciRiga(mis));
      int nc=0;
   	  for(int i=rows_campi;i<rows_campi+num_campi;i++)
   	   {
   	   	aux=row[i];	if(aux=="1") { cam+=etich_campi.at(i-rows_campi)+", "; nc++; }
   	   }
   	  cam.chop(2);
   	  if(nc==0) cam=tr("Nessun campo");
   	  table->setItem(r,5,inserisciRiga(cam));
   	  r++;
     }
    mysql_free_result(rs);
    if(r==0) 
     {
     	if(infobox->isHidden())
     	 {
     	  infobox->setText(tr("Nessuna tipologia di articoli trovata!"));
 	      infobox->show();
 	     }
     }
   }
 }

void ARGrigliaTipoArt::delTipoArt()
 {
 	MYSQL_RES *rs;
 	QString tipo_articoloID;

  if(table->currentRow()<0)
   {
    warnbox->setText(tr("Nessuna tipologia di articoli selezionata."));
 	  warnbox->show();
 	  return;
   }
  yesnobox->setText(tr("Vuoi veramente cancellare la tipologia di articoli?"));
  if(yesnobox->exec()==QMessageBox::No) return;
  tipo_articoloID=table->item(table->currentRow(),0)->text();
  rs=sql->doQueryRS("SELECT * FROM articoli WHERE tipo_articoloID='"+tipo_articoloID+"'");
  if(rs)
   {
    if(mysql_num_rows(rs)==0)
     {
      // Entro nella sezione critica
      mainWin->sql->connetti();
      if(!mainWin->sql->isBloccatoPer(sql->getDbName()+".carico")) // .carico_n
       {
        warnbox->setText(tr("Un'altro utente sta occupando la sezione tipologia articoli,\nnon posso cancellare la tipologia adesso. Riprova pi tardi."));
 	      warnbox->exec();
        mainWin->sql->disconnetti();
        return;
       }
      mainWin->sql->disconnetti();
   	  sql->doQuery("DELETE FROM tipi_articolo WHERE tipo_articoloID='"+tipo_articoloID+"'");
      infobox->setText(tr("Tipologia cancellata!"));
      infobox->show();
      visTipoArt();
     }
    else
     {
   	  warnbox->setText(tr("Non posso cancellare la tipologia di articoli\npoich sono presenti, in magazzino, articoli di questa tipologia."));
      warnbox->show();
     }
    mysql_free_result(rs);
   }
 }

void ARGrigliaTipoArt::resRicerca()
 {
 	descr->clear();
 	iva->clear();
 	visTipoArt();
 }

QTableWidgetItem *ARGrigliaTipoArt::inserisciRiga(QString str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QTableWidgetItem *ARGrigliaTipoArt::inserisciRiga(const char *str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

void ARGrigliaTipoArt::setEtichette(QStringList etic,QStringList et_campi,int r_iva,int rs_campi)
 {
  etichette=etic;
 	num_mis=etichette.count();
 	etich_campi=et_campi;
 	num_campi=etich_campi.count();
 	row_iva=r_iva;
 	rows_campi=rs_campi;
 }

QString ARGrigliaTipoArt::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }
