#include <QPushButton>
#include <QGroupBox>
#include <QLabel>
#include <QLineEdit>
#include <QMessageBox>
#include <QStringList>
#include <QCheckBox>
#include <QLineEdit>
#include <QIntValidator>

#include "ARsql.h"
#include "ARFinestra.h"

#include "ARTipoArticolo.h"

ARTipoArticolo::ARTipoArticolo(QWidget *parent) : QWidget(parent)
 {
 	posx_campi=84+70*8;
 	mainWin=(ARFinestra *)parent;
 	sql = new ARsql(this);
 	infobox = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
 	warnbox = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
 	cornice = new QGroupBox(tr("Inserisci nuovo tipo di articolo "),this);
 	cornice->setGeometry(2,0,798,489);

  _descr = new QLabel(tr("Descrizione"),this);    _descr->setGeometry (8,20, 80,24);
   descr = new QLineEdit("",this);                 descr->setGeometry (78,20,300,24);
   descr->setMaxLength(255);
  _misure = new QLabel(tr("Misure da includere nella tipologia:"),this);
  _misure->setGeometry(8,50,200,24);
  _campi  = new QLabel(tr("Campi da attivare nella tipologia:"),this);
  _campi->setGeometry(posx_campi,50,200,24);  
  _iva    = new QLabel(tr("IVA (%)"),this);
  iva     = new QLineEdit("20",this);
  iva->setValidator(new QIntValidator(0,100,iva));
  _sconto = new QLabel(tr("Sconto (%)"),this);
  sconto  = new QLineEdit("20",this);
  sconto->setValidator(new QDoubleValidator(-9999.0,9999.0,2,sconto));

 	esegui = new QPushButton(QIcon("pic/tipi_add.png"),tr("Crea"),this);
 	esegui->setGeometry(691,462,106,24);
 	ckall = new QPushButton(QIcon("pic/ckall.png"),tr("Selezione tutto"),this);
 	ckall->setGeometry(8,462,108,24);
 	cknone = new QPushButton(QIcon("pic/cknone.png"),tr("Deseleziona tutto"),this);
 	cknone->setGeometry(120,462,108,24);
 	ckinvert = new QPushButton(QIcon("pic/ckinvert.png"),tr("Inverti selezione"),this);
 	ckinvert->setGeometry(232,462,108,24);
 	
  connect(esegui,SIGNAL(clicked()),this,SLOT(addTipoArticolo()));
  connect(ckall,SIGNAL(clicked()),this,SLOT(ckAll()));
  connect(cknone,SIGNAL(clicked()),this,SLOT(ckNone()));
  connect(ckinvert,SIGNAL(clicked()),this,SLOT(ckInvert()));

 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
  setGeometry(0,61,800,490);
  azione=ARTIPOARTICOLO_ADD;  
  hide();
 }

ARTipoArticolo::~ARTipoArticolo() { delete[] ckmis; delete[] ckcampi; }

void ARTipoArticolo::addTipoArticolo()
 {
 	int n=0;
 	QString query,aux;
  QString descr=quote(this->descr->text());
  QString mis[num_mis],campi[num_campi];
  QString iva=quote(this->iva->text());
  QString sconto=quote(this->sconto->text());
  QString ts=sql->timeStamp();
  QString data=sql->data(ts);
  QString ora=sql->ora(ts);
  for(int i=0;i<num_mis-1;i++)
   {
    if(ckmis[i].checkState()==Qt::Unchecked) mis[i]="0";
    else { mis[i]="1"; n++; }
   }
  if(n==0) mis[num_mis-1]="1"; else mis[num_mis-1]="0";

  for(int i=0;i<num_campi;i++) // Colore, fondo, tacco, stagione
   {
    if(ckcampi[i].checkState()==Qt::Unchecked) campi[i]="0"; else campi[i]="1";
   }

 	if(isAzione(ARTIPOARTICOLO_ADD))
 	 {
 	  if(!checkForm())
 	   {
 	   	query="INSERT INTO tipi_articolo VALUES('0','"+descr+"'";
 	   	for(int i=0;i<num_mis;i++) query+=","+mis[i];
 	   	for(int i=0;i<num_campi;i++) query+=","+campi[i];
 	   	query+=",'"+iva+"','"+sconto+"','"+data+"','"+ora+"','"+ts+"')";
 	   	if(sql->doQuery(query))
       {
        infobox->setText(tr("Nuova tipologia di articoli creata"));
        infobox->exec();
        clearForm();
 	     }
 	   }
 	 }
 	if(isAzione(ARTIPOARTICOLO_EDIT))
 	 {
 	  if(!checkForm())
 	   {
 	   	n=0; aux="";
 	   	query="UPDATE tipi_articolo SET descrizione='"+descr+"'";
 	   	for(int i=0;i<num_mis-1;i++)
 	   	 {
 	   	 	if(mis[i]=="1") n++;
 	   	 	aux=etichette.at(i); if(aux.at(aux.length()-1)=='') { aux.chop(1); aux.append("m"); }
 	   	  query+=", _"+aux+"="+mis[i];
 	   	 }
 	   	if(n==0) query+=", _QTA=1"; else query+=", _QTA=0";
 	   	query+=", colore='"+campi[0]+"'";
 	   	query+=", fondo='"+campi[1]+"'";
 	   	query+=", tacco='"+campi[2]+"'";
 	   	query+=", stagione='"+campi[3]+"'";
 	   	query+=", iva='"+iva+"'";
 	   	query+=", sconto='"+sconto+"'";
 	   	query+=" WHERE tipo_articoloID='"+tipo_articoloID+"'";
      // Entro nella sezione critica
      mainWin->sql->connetti();
      if(!mainWin->sql->isBloccatoPer(sql->getDbName()+".carico")) // .carico_n
       {
        warnbox->setText(tr("Un'altro utente sta occupando la sezione tipologia articoli,\nnon posso modificare la tipologia adesso. Riprova pi tardi."));
 	      warnbox->exec();
        mainWin->sql->disconnetti();
        return;
       }
      mainWin->sql->disconnetti();
 	 	  if(sql->doQuery(query))
 	 	   {
        warnbox->setText(tr("Tipologia articoli modificata e salvata!"));
        warnbox->exec(); 
        mainWin->visTipoArt();
       }
     }
 	 }
 }

bool ARTipoArticolo::setForm(QString tipo_articoloID)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
  QString aux;

  rs=sql->doQueryRS("SELECT * FROM tipi_articolo WHERE tipo_articoloID='"+tipo_articoloID+"'");
  if(rs)
   {
    if(mysql_num_rows(rs)!=1) { mysql_free_result(rs); return false; }
    row=mysql_fetch_row(rs);
    descr->setFocus();
 	  descr->setText(row[1]);
    for(int i=0;i<num_mis-1;i++)
     {
 	    aux=row[i+2];
 	    if(aux=="1") ckmis[i].setCheckState(Qt::Checked);
 	    else ckmis[i].setCheckState(Qt::Unchecked);
 	   }
    for(int i=0;i<num_campi;i++)
     {
 	    aux=row[num_mis+2+i];
 	    if(aux=="1") ckcampi[i].setCheckState(Qt::Checked);
 	    else ckcampi[i].setCheckState(Qt::Unchecked);
 	   }
 	  iva->setText(QString(row[num_mis+6]));
 	  sconto->setText(QString(row[num_mis+7]));
 	  mysql_free_result(rs);
 	  return true;
 	 }
 	return false;
 }

void ARTipoArticolo::clearForm()
 {
 	descr->setFocus();
 	descr->clear();
 	iva->setText("20");
 	sconto->setText("0");
  for(int i=0;i<num_mis-1;i++) ckmis[i].setCheckState(Qt::Unchecked);
  for(int i=0;i<num_campi;i++) ckcampi[i].setCheckState(Qt::Unchecked);
 }

bool ARTipoArticolo::checkForm()
 {
 	if(quote(this->descr->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire la descrizione della tipologia"));
 	  warnbox->exec();
 	  return true;
 	 }
 	return false;
 }

QString ARTipoArticolo::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }

void ARTipoArticolo::setEtichette(QStringList etic,QStringList et_campi)
 {
 	// Deve essere chiamata solo una volta
 	int r=0,c=0;
 	
 	etichette=etic;
 	num_mis=etichette.count();
 	ckmis = new QCheckBox[num_mis];
 	for(int i=0;i<num_mis-1;i++)
 	 {
 	  ckmis[i].setText(etichette.at(i));
 	  ckmis[i].setParent(this);
 	  ckmis[i].setGeometry(8+c*68,75+r*30,70,24);
 	  r++; if((i+1)%13==0) { c++; r=0; }
 	 }

 	etich_campi=et_campi;
 	num_campi=etich_campi.count();
 	ckcampi = new QCheckBox[num_campi];
 	for(int i=0;i<num_campi;i++)
 	 {
 	  ckcampi[i].setText(etich_campi.at(i));
 	  ckcampi[i].setParent(this);
 	  ckcampi[i].setGeometry(posx_campi,75+i*30,70,24);
 	 }
 	_iva->setGeometry(posx_campi,75+num_campi*30,150,24);
 	 iva->setGeometry(posx_campi+60,75+num_campi*30,50,24);
 	_sconto->setGeometry(posx_campi,75+(num_campi+1)*30,150,24);
 	 sconto->setGeometry(posx_campi+60,75+(num_campi+1)*30,50,24);
 }

void ARTipoArticolo::ckAll()
 {
 	for(int i=0;i<num_mis-1;i++)
 	 if(ckmis[i].checkState()==Qt::Unchecked)
 	  ckmis[i].setCheckState(Qt::Checked);
 }

void ARTipoArticolo::ckNone()
 {
 	for(int i=0;i<num_mis-1;i++)
 	 if(ckmis[i].checkState()==Qt::Checked)
 	  ckmis[i].setCheckState(Qt::Unchecked);
 }

void ARTipoArticolo::ckInvert()
 {
 	for(int i=0;i<num_mis-1;i++)
 	 if(ckmis[i].checkState()==Qt::Checked)
 	  ckmis[i].setCheckState(Qt::Unchecked);
 	 else
 	  ckmis[i].setCheckState(Qt::Checked);
 }  

void ARTipoArticolo::setTipoArticoloID(QString tipoartID) { tipo_articoloID=tipoartID; }

void ARTipoArticolo::setAzione(int azio) { azione=azio; }

bool ARTipoArticolo::isAzione(int azio) { if(azione==azio) return true; else return false; }
